﻿<!-- 	@Author: Erik Tute
        @Version: 1.0.0
        @description: .
-->

<!DOCTYPE html>
<html> 
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width">
        <link rel=stylesheet href=style.css>
        <script language=javascript type=text/javascript src="jquery-2.2.0.min.js"></script>
        <script language=javascript type=text/javascript src="jquery-ui.min.js"></script>
        <script language=javascript type=text/javascript src="knockout-3.4.0.js"></script>
        <script language=javascript type=text/javascript src="instructionsVM.js"></script>
        <script language=javascript type=text/javascript src="utils.js"></script>
        <script language=javascript type=text/javascript src="staticData.js"></script>
        <title>ETLBuilder</title>
    </head>
    <body>   
        <div class="overlayWindow menu" data-bind="visible: columns().length>0">
            <button data-bind='click: toJSON, enable: columns().length > 0'>To JSON</button><br>
        </div>

        <div class="overlayWindow exampleData" data-bind="visible: exampleData().length>0" title="Example Data">
            <table class="exampleData">
				<tr class="exampleData" data-bind="foreach: exampleDataHeader">
                        <th data-bind="text: $data" class="exampleData"></th>
                 </tr>
                <tbody data-bind="foreach: exampleData">
                    <tr class="exampleData" data-bind="foreach: row">
                        <td data-bind="text: $data" class="exampleData"></td>
                    </tr>
                </tbody>
            </table>
        </div>

        <div class="overlayWindow exampleCommit" data-bind="visible: myCommit" title="Example of how a commit would look like if current instructions would be invoked on example data">
            <button data-bind='click: updateCommit'>Refresh</button>
            <button data-bind='click: testCommit, enable: ((uname() != "") && (pw() != ""))'>POST</button>
            <input data-bind="value: uname" title="Think-EHR username"/>
            <input data-bind="value: pw" type="password" title="Think-EHR password"/><br>
            <textarea data-bind="value: myCommit"></textarea>
        </div>

        <div class="overlayWindow centerOfAttention" data-bind="visible: myJSON">
            <button data-bind='click: clearJSON'>Hide</button><br>
            <textarea class="centerOfAttention taJSON" data-bind="text: myJSON"></textarea>
        </div>

        <div class="overlayWindow centerOfAttention" data-bind="visible: columns().length==0">
            <p>Please enter input data here:</p>
			<button data-bind='click: addRawInstructions'>Apply input data</button>
            <textarea class="centerOfAttention inputData" data-bind="value: instructionsRaw"></textarea>
        </div>

        <div class="overlayWindow probableParams" data-bind="visible: probableParams().length>0" title="Probable Parameters">
            <button data-bind='click: clearProbableParams'>Hide</button><br>
            <table class="probableParams">
                <tbody data-bind="foreach: probableParams">
                    <tr class="probableParam">
                        <td data-bind="text: $data, click: $root.changeParameterValue" class="probableParams"></td>
                    </tr>
                </tbody>
            </table>
        </div>

        <div class="instructions" data-bind="visible: columns().length>0">
            <a href='#' class="add column" data-bind='click: $root.addColumn'>+</a>
            <ul id="columns" class="columns" data-bind="foreach: columns">
                <li class="column">
                    For column: <input class="label column" data-bind="value: colName"/> 
                    <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "columns")'>X</a>
                    <ul class="cAndAs" data-bind="foreach: cAndAs">
                        <li class="condition">
                            on condition: <input class="label" data-bind="value: condition" list="probableConditions"/>
                            <datalist id='probableConditions'data-bind="foreach: conditionsData">
                                <option data-bind="attr: { label: $data, value: $data}">
                            </datalist>
                            <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "cAndAs")'>X</a>
                            <ul class="actions" data-bind="foreach: actions">
                                <li class="action">
                                    invoke method: <input class="label action" data-bind="value: method, event: {change: $root.actionChanged}" list="probableActions"/>
                                    <datalist id='probableActions' data-bind="foreach: actionsData">
                                        <option data-bind="attr: { label: $data.method, value: $data.method}">
                                    </datalist>
                                    <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "actions")'>X</a><br>
                                    <a class="action">with parameters:</a>
                                    <table class="parameters" data-bind="foreach: parameters">
                                        <tr class="parameter">
                                            <td data-bind="text: parameterName" class="label"></td>
                                            <td style="width:100%">
                                                <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "parameters")'>X</a>
                                                <input class="label parameter parameterInput" data-bind="value: parameter, click: $root.editParameter.bind($data, $parent)"/>
                                            </td>
                                        </tr>
                                    </table>
                                    <a href='#' class="add parameter" data-bind='click: $root.addParameter'>+</a>
                                </li>
                            </ul>
                            <a href='#' class="add action" data-bind='click: $root.addAction'>+</a>
                        </li>
                    </ul>
                    <a href='#' class="add condition" data-bind='click: $root.addCondition'>+</a>
                </li>                
            </ul>
        </div>

        <script language="JavaScript">
            $(function() {
                $( ".overlayWindow" ).draggable();
            });
            
            var iVM = new InstructionsVM();
            ko.applyBindings(iVM);

			$(".inputData").focus();
			$(".inputData").select();
	
            //GUI-Interaktionen
            
            //Drag and Drop für Parameter-Vorschläge
            $(".probableParams").on("dragstart", ".probableParams", function(e) {
                e.originalEvent.dataTransfer.setData("type", "parameterSuggestion");
                e.originalEvent.dataTransfer.setData("text", $( this ).text());
            });
        </script>
    </body>
</html>